@cls

@echo off
@if "%1" == ""         goto ALL
@if "%1" == "all"      goto ALL
@if "%1" == "base"     goto BASE
@if "%1" == "gui"      goto GUI
@if "%1" == "hw"       goto HARDWARE
@if "%1" == "clean"    goto CLEAN
@if "%1" == "docs"     goto DOCS
@if "%1" == "?"        goto HELP

:ALL
@echo Building Base...
@javac -deprecation com\mc\monkeynes\base\*.java -d ..\classes
@echo Building GUI...
@javac -deprecation com\mc\monkeynes\gui\*.java -d ..\classes
@echo Building Hardware...
@javac -deprecation com\mc\monkeynes\hardware\*.java -d ..\classes
@goto DONE


:BASE
@echo Building Base...
@javac -deprecation com\mc\monkeynes\base\*.java -d ..\classes
@goto DONE

:GUI
@echo Building GUI...
@javac -deprecation com\mc\monkeynes\gui\*.java -d ..\classes
@goto DONE

:HARDWARE
@echo Building Hardware...
@javac -deprecation com\mc\monkeynes\hardware\*.java -d ..\classes
@goto DONE

:CLEAN
@echo Cleaning out classes...
@rd /S /Q ..\classes
@md ..\classes
@echo Cleaning generated docs...
@rd /S /Q ..\docs
@md ..\docs
@goto DONE

:DOCS
@set PACKAGES=com.mc.monkeynes.base com.mc.monkeynes.gui com.mc.monkeynes.hardware

@javadoc -sourcepath . -classpath ..\classes -d ..\docs -author %PACKAGES%
@goto DONE



:HELP
@echo Use:  build [package]
@echo.
@echo -blank-     build all packages
@echo all         build all packages
@echo clean       - delete all class files (doesn't build)
@echo             - delete cache files/cookie files
@echo             - delete ini files
@echo             - delete all generated docs
@echo docs        build all JavaDocs
@echo ?           show this help display
@echo.
@echo Currently supported packages:
@echo base        build base package
@echo gui         build gui package
@echo hw          build hardware package
@echo.
@goto DONE

:DONE
