package com.mc.monkeynes.hardware;

import com.mc.monkeynes.base.*;

public class NesMainMemory
{
  // 64k (it's all that is addressable and part of it is in the rom)
  private int[] memory = new int[0x0000FFFF];
  
  public NesMainMemory()
  {
    // Do nothing.
  }
  
  public int read( int addr )
  {
    return memory[MathHelper.getWrappedAddress(addr)];
  }

  public int[] read( int startAddr, int stopAddr )
  {
    int j = 0;
    int[] temp = new int[stopAddr - startAddr + 1];
    
    for( int i = startAddr; i <= stopAddr; i++ )
    {
      temp[j] = read(i);
      j++;
    }
    
    return temp;
  }  
  
  public void write( int addr, int val )
  {
    memory[MathHelper.getWrappedAddress(addr)] = val;
  }
  
  public void write( int startAddr, int[] data )
  {
    // writes the whole input buffer
    for( int i = 0; i < data.length; i++ )
      write( startAddr + i, data[i] );
  }

  public void write( int startAddr, int[] data, int len )
  {
    // writes up to len of the input buffer
    for( int i = 0; i < len; i++ )
      write( startAddr + i, data[i] );
  }

}