package com.mc.monkeynes.hardware;

import com.mc.monkeynes.base.*;

public class NesVideoMemory
{
  // 64k (4x shadowed in 16k chunks)
  private int[] memory = new int[0x0000FFFF];
  
  public NesVideoMemory()
  {
    // Do nothing.
  }
  
  public int read( int addr )
  {
    return memory[MathHelper.getWrappedAddress(addr)];
  }

  public int[] read( int startAddr, int stopAddr )
  {
    int j = 0;
    int[] temp = new int[stopAddr - startAddr + 1];
    
    for( int i = startAddr; i <= stopAddr; i++ )
    {
      temp[j] = read(i);
      j++;
    }
    
    return temp;
  }  
  
  public void write( int addr, int val )
  {
    // Shadow it
    memory[MathHelper.getWrappedAddress(addr + 0x00000000)] = val;
    memory[MathHelper.getWrappedAddress(addr + 0x00004000)] = val;
    memory[MathHelper.getWrappedAddress(addr + 0x00008000)] = val;
    memory[MathHelper.getWrappedAddress(addr + 0x0000C000)] = val;
  }
  
  public void write( int startAddr, int[] data )
  {
    // writes the whole input buffer
    for( int i = 0; i < data.length; i++ )
      write( startAddr + i, data[i] );
  }

  public void write( int startAddr, int[] data, int len )
  {
    // writes up to len of the input buffer
    for( int i = 0; i < len; i++ )
      write( startAddr + i, data[i] );
  }

}